#include <stdio.h>
#include <stdlib.h>
typedef struct list
{
	double data;
	struct list *next;
} list;
list *list_new(double data);
void list_append(list *after, double data);
void list_prepend(list *before, double data);
void list_delete(list *dest);
int main(void)
{   list *l = list_new(1.0);
	list_append(l, 2.0);
	list_append(l->next, 3.0);
	list_append(l->next->next, 4.0);
	list_append(l->next->next->next, 5.0);
	/*l = */list_prepend(l, 0.0);
	/*l = */list_prepend(l, -1.0);
	/*l = */list_prepend(l, -2.0);
	/*l = */list_prepend(l->next, -3.0);
	for (list *temp = l; temp != NULL; temp = temp->next)
	{
		printf("%lf\n", temp->data);
	}
	list_delete(l); return 0;}
list *list_new(double data)
{   list *dest = malloc(sizeof(list));
	dest->data = data;
	dest->next = NULL;
	return dest;
}
void list_append(list *after, double data)
{
	list *temp = after->next;
	after->next = list_new(data);
	after->next->next = temp;
}
void list_prepend(list *before, double data)
{
	double temp = before->data;
	list *templist = before->next;
	before->data = data;
	before->next = list_new(data);
	before->next->data = temp;
	before->next->next = templist;
}
void list_delete(list *dest)
{
	if (dest->next != NULL)
	{
		list_delete(dest->next);
	}free(dest);
}
